"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGrafservHooks = void 0;
const graphile_config_1 = require("graphile-config");
function getGrafservHooks(resolvedPreset) {
    const hooks = new graphile_config_1.AsyncHooks();
    (0, graphile_config_1.applyHooks)(resolvedPreset.plugins, (p) => p.grafserv?.hooks, (name, fn, _plugin) => {
        const context = {
            resolvedPreset,
        };
        hooks.hook(name, ((...args) => fn(context, ...args)));
    });
    return hooks;
}
exports.getGrafservHooks = getGrafservHooks;
//# sourceMappingURL=hooks.js.map