import type { AsyncExecutionResult, ExecutionResult } from "grafast/graphql";
import * as graphql from "grafast/graphql";
export declare function defaultMaskError(error: graphql.GraphQLError): graphql.GraphQLError;
export declare function makeMaskError(callback: (error: graphql.GraphQLError) => graphql.GraphQLError): (error: graphql.GraphQLError) => graphql.GraphQLError;
export declare function optionsFromConfig(config: GraphileConfig.ResolvedPreset): {
    outputDataAsString: boolean;
    graphqlPath: string;
    graphqlOverGET: boolean;
    graphiql: boolean;
    graphiqlOnGraphQLGET: boolean;
    graphiqlPath: string;
    watch: boolean;
    eventStreamPath: string;
    maxRequestLength: number;
    explain: boolean | string[] | undefined;
    schemaWaitTime: number;
    maskError: (error: graphql.GraphQLError) => graphql.GraphQLError;
    maskPayload: (payload: any) => any;
    maskIterator: (result: AsyncGenerator<AsyncExecutionResult>) => AsyncGenerator<AsyncExecutionResult>;
    maskExecutionResult: (result: ExecutionResult | AsyncGenerator<AsyncExecutionResult>) => any;
};
export type OptionsFromConfig = ReturnType<typeof optionsFromConfig>;
//# sourceMappingURL=options.d.ts.map